#define _WINSOCKAPI_      // Prevent winsock.h from being included
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "HttpDlg.h"
#include "Global.h"
#include "FileMan.h"
#include "UrlsDlg.h"
#include "Mixmaster.h"
#include "Cyberpunk.h"
#include "PgpMail.h"
#include "HelpDlg.h"
#include "docmsgdlg.h"
#include "smtpdlg.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma link "HttpProt"
#pragma link "explbtn"
#pragma resource "*.dfm"
THttpForm *HttpForm;
AnsiString httpretval;
//---------------------------------------------------------------------------
bool __fastcall GetRemailerStats(TForm *owner, bool attended)
{
   HttpForm = new THttpForm(owner);
   CenterDialog(HttpForm,owner);
   bool ok = HttpForm->Execute(attended);
   delete HttpForm;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall THttpForm::THttpForm(TComponent* Owner)
    : TForm(Owner)
{
   DocMemo->Clear();
   DocMemo->Font->Name = GetAppIni("FontName","Courier New");
   DocMemo->Font->Size = GetAppIni("FontSize","").ToIntDef(10);
   ErrorCheck->Checked = GetAppIni(StatsErrCheck,"").ToIntDef(1);
   TimeOut = GetAppIni(StatsTimeOut,"").ToIntDef(30);
   CenterDialog(this);

   PageControl1->ActivePage = TabSheet1;
   TabSheet2->TabVisible = false;
   Label1->Caption = "";

   LoadHttpInfo();
   HttpCli1->RcvdStream = NULL;
   Tabs = TabSet->Tabs;
   CancelAnyway = false;
   Cancelled = false;
   Attended = false;
}
//---------------------------------------------------------------------------
__fastcall THttpForm::~THttpForm()
{
   for (int i=0; i<Tabs->Count; i++)
      delete dynamic_cast<TStrings*>(Tabs->Objects[i]);
   delete HttpCli1->RcvdStream;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::WMGetButtonClick(TMessage& Msg)
{
   GetBtnClick();
}
//---------------------------------------------------------------------------
void __fastcall SetCBoxCur(TComboBox *cbox, int listpos)
{
   if (listpos<cbox->Items->Count) cbox->ItemIndex = listpos;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::LoadURLs()
{
   GetAppData(MListCBox->Items,StatsURLs+PS+MListTxt); SetCBoxCur(MListCBox,0);
   GetAppData(MRingCBox->Items,StatsURLs+PS+MRingTxt); SetCBoxCur(MRingCBox,0);
   GetAppData(MTyp2CBox->Items,StatsURLs+PS+MTyp2Txt); SetCBoxCur(MTyp2CBox,0);
   GetAppData(CListCBox->Items,StatsURLs+PS+CListTxt); SetCBoxCur(CListCBox,0);
   GetAppData(CRingCBox->Items,StatsURLs+PS+CRingTxt); SetCBoxCur(CRingCBox,0);
   GetAppURLs();
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::SaveErrChkLog(TStrings *Log)
{
   if (!Log || !Log->Count) return;
   TStringList *list = new TStringList();
   GetAppData(list,ErrChkLog);
   while (list->Count>=MaxLog)
   {
      PutAppData(ErrChkLog+PS+list->Strings[0],NULL);
      list->Delete(0);
   }
   AnsiString logstr = SMTPPOP3logtime()+" "+Log->Strings[Log->Count-1];
   PutAppData(ErrChkLog+PS+logstr,Log);
   delete list;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   switch (ModalResult)
   {
      case mrOk: SaveStatistics(); break;
      case mrCancel:
         if (GoodTabs())
         {
            switch (MsgBoxHwnd(Handle,
               "Your new remailer docs are not saved!\n\nSave them now?",
               "Remailer Documents",MB_YESNOCANCEL))
            {
               case ID_CANCEL:
                  CanClose = false;
                  break;
               case ID_YES:
                  SaveStatistics();
                  break;
            }
         }
   }
   if (!CanClose) return;

   if (CancelAnyway) ModalResult = mrCancel;
   PutAppIni(StatsErrCheck,ErrorCheck->Checked ? "1":"0");
   StoreHttpInfo();
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::CheckDocumentsExist()
{
   int reply;
   AnsiString mlisttxt=MixDir()+MListTxt,mringtxt=MixDir()+MRingTxt,
              clisttxt=MixDir()+CListTxt,cringtxt=MixDir()+CRingTxt;

   if (!Cancelled && !FileExists(mlisttxt) && MRingBox->Checked && !MListBox->Checked)
   {
      reply = MsgBoxHwnd(Handle,
        " Your 'mlist.txt' document is missing. Shall I get it while online?  ",
        "Mixmaster Statistics",
         MB_YESNOCANCEL
      );
      switch (reply)
      {
         case IDCANCEL:
            Cancelled = true;
            break;
         case IDYES:
            MListBox->Checked = true;
            break;
      }
   }
   else
   if (!Cancelled && !FileExists(mringtxt) && MListBox->Checked && !MRingBox->Checked)
   {
      reply = MsgBoxHwnd(Handle,
        "  Your 'pubring.mix' keyring is missing. Shall I get it while online?  ",
        "Mixmaster Keyring",
         MB_YESNOCANCEL
      );
      switch (reply)
      {
         case IDCANCEL:
            Cancelled = true;
            break;
         case IDYES:
            MRingBox->Checked = true;
            break;
      }
   }

   if (!Cancelled && !FileExists(clisttxt) && CRingBox->Checked && !CListBox->Checked)
   {
      reply = MsgBoxHwnd(Handle,
        "  Your 'rlist.txt' document is missing. Shall I get it while online?  ",
        "Cyberpunk Statistics",
         MB_YESNOCANCEL
      );
      switch (reply)
      {
         case IDCANCEL:
            Cancelled = true;
            break;
         case IDYES:
            CListBox->Checked = true;
            break;
      }
   }
   else
   if (!Cancelled && !FileExists(cringtxt) && CListBox->Checked && !CRingBox->Checked)
   {
      reply = MsgBoxHwnd(Handle,
        "  Your 'pubring.asc' keyring is missing. Shall I get it while online?  ",
        "Mixmaster Keyring",
         MB_YESNOCANCEL
      );
      switch (reply)
      {
         case IDCANCEL:
            Cancelled = true;
            break;
         case IDYES:
            CRingBox->Checked = true;
            break;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::ClearDocuments()
{
   for (int t=0; t<Tabs->Count; t++)
      delete dynamic_cast<TStrings*>(Tabs->Objects[t]);
   DocMemo->Clear();
   Tabs->Clear();
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::GetDocsClick(TObject *Sender)
{
   if (!MListBox->Checked && !MRingBox->Checked && !MTyp2Box->Checked &&
       !CListBox->Checked && !CRingBox->Checked)
   {
      MsgBoxHwnd(Handle,"Nothing checked for update!","Document Error",MB_OK);
      return;
   }
   bool cancel=false; GetAppURLs();
   if (!Tabs->Count) CheckDocumentsExist();
   if (GoodTabs())
   {
      switch (MsgBoxHwnd(Handle,
         "You have good remailer docs not saved!\n\nSave them now?",
         "Remailer Documents",MB_YESNOCANCEL))
      {
         case ID_YES:
            SaveStatistics();
            break;
         case ID_CANCEL:
            cancel = true;
            break;
      }
   }
   if (cancel) return;
   ClearDocuments();
   GetBtnClick();
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::IsTab(int Index, AnsiString &TabName)
{
   if (Index>=0 && Index<Tabs->Count)
      return Tabs->Strings[Index]==TabName;
   return false;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::GetBtnClick()
{
   if (!MListBox->Checked && !MRingBox->Checked && !MTyp2Box->Checked &&
       !CListBox->Checked && !CRingBox->Checked)
   {
      MsgBoxHwnd(Handle,"Nothing checked for update!","Document Error",MB_OK);
      Cancelled = true;
   }
   if (Cancelled)
   {
      ResetCheckboxes();
      return;
   }

   if (!Timer1->Enabled) Timer1->Enabled = true;
   if (GetDocs->Enabled && GetDocs->Caption=="Get Docs")
   {
      TabSheet1->Enabled = false;
      TabSheet2->Enabled = false;
   }

   GetDocs->Enabled = false;
   OkBtn->Enabled = false;
   HelpBtn->Enabled = false;

   if (MListBox->Enabled && MListBox->Checked)
      GetStatistics(MListURL,MListBox,MListTxt);
   else
   if (MRingBox->Enabled && MRingBox->Checked)
      GetStatistics(MRingURL,MRingBox,MRingTxt);
   else
   if (MTyp2Box->Enabled && MTyp2Box->Checked)
      GetStatistics(MTyp2URL,MTyp2Box,MTyp2Txt);
   else
   if (CListBox->Enabled && CListBox->Checked)
      GetStatistics(CListURL,CListBox,CListTxt);
   else
   if (CRingBox->Enabled && CRingBox->Checked)
      GetStatistics(CRingURL,CRingBox,CRingTxt);
   else
   {
      ResetCheckboxes(); Label1->Caption = "";
      ProgressBar1->Visible = false; Label1->Caption = "";
      TabSet->TabIndex = Tabs->Count-1;
      if (ErrorCheck->Checked)
      {
         Sleep(200);
         TStringList *doc;
         Tabs->AddObject(ChecksPage,NULL);
         TabSet->TabIndex = Tabs->Count-1;
         Application->ProcessMessages();
         bool ok1=true,ok2=true,ok3=true,ok4=true;
         for (int i=0; i<Tabs->Count; i++)
         {
            if ((doc=GetDoc(i))!=NULL)
            {
               if (IsTab(i,MListTxt)) ok1=MixListOk(doc); else
               if (IsTab(i,MRingTxt)) ok2=MixRingOk(doc); else
               if (IsTab(i,CListTxt)) ok3=CpkListOk(doc); else
               if (IsTab(i,CRingTxt)) ok4=CpkRingOk(doc);
            }
         }
         if (!ok1 || !ok2 || !ok3 || !ok4)
         {
            if (!Attended)
               Display("OPERATION CANCELLED");
            Display("Done!");
            CancelAnyway = true;
            Cancelled = true;
            Attended = true;
            GetDocs->Enabled = true;
            HelpBtn->Enabled = true;
            OkBtn->Enabled = true;
            GetBtnClick();
            return;
         }
      }

      if (ErrorCheck->Checked)
      {
         if (ReportDocumentsAndProblems()) Display("OK!"); else
         {
            if (!Attended)
               Display("OPERATION CANCELLED");
            Display("Done!");
            Attended = true;
         }
         AppProcessMessages(); Sleep(300);
      }

      ActiveControl = DocMemo;
      ProgressBar1->Position = 100;
      AppProcessMessages(); Sleep(200);
      TabSheet1->Enabled = true;
      TabSheet2->Enabled = true;
      UrlsBtn->Enabled = true;
      ProxyBtn->Enabled = true;
      GetDocs->Enabled = true;
      OkBtn->Enabled = true;
      HelpBtn->Enabled = true;
      Label1->Caption = "";
      Cancelled = false;

      if (Attended) MyBeep(MB_OK); // if attended, just this line
      else
      {
         ModalResult = !Cancelled || (Cancelled && Tabs->Count>1) ? mrOk:mrCancel;
         ProgressBar1->Visible = false;
         CancelBtn->Enabled = false;
         GetDocs->Enabled = false;
         OkBtn->Enabled = false;
         HelpBtn->Enabled = false;
         Sleep(500);
      }
   }
}
//---------------------------------------------------------------------------
TStringList* __fastcall THttpForm::GetDocument(AnsiString &DocName)
{
   TStringList *doc;
   AnsiString md=MixDir();
   // if the doc was not downloaded get it from disk
   int Index=Tabs->IndexOf(DocName);
   if (Index>=0) doc = GetDoc(Index);
   else
   {
      doc = new TStringList();
      if (FileExists(MixDir()+DocName)) doc->LoadFromFile(MixDir()+DocName);
      Tabs->AddObject(DocName,NULL);
      TabSet->TabIndex = Tabs->Count-1;
      Application->ProcessMessages(); Sleep(200);
      SetDoc(DocName,doc);
   }
   // special handling cpunk keyring
   if (DocName==CRingTxt && HasPgp()) CpkBlockToKeys(doc);
   // end special
   SetDocMemo(doc);
   return doc;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::CorruptDoc(TStrings *Doc)
{
   return Doc && Doc->Text.Trim().Pos(CorruptReport)==1;
}
//---------------------------------------------------------------------------
void __fastcall ClearTypeList(TStrings *TypeList)
{  // clears type1.list or type2.list of all but disables (#)
   int t=0; while (t<TypeList->Count)
   {
      if (TypeList->Strings[t].Pos("#")!=1) TypeList->Delete(t);
      else t++;
   }
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::ReportDocumentsAndProblems()
{
   bool mixOk=true,cpkOk=true;
   // LoadDocument returns a pointer to that document in the Tabs array.
   // If the document is not present on any Tab, it is loaded from disk
   // into the Tabs array. Either way, a pointer to the doc is returned.
   AnsiString md=MixDir();
   TStrings *mlist,*mring,*type2,*clist,*cring,*type1;
   DocMemo->Cursor = crHourGlass;
   // test mixmaster documents
   if (MListBox->Checked || MRingBox->Checked)
   {
      type2=GetDoc(MTyp2Txt);
      // if no pubring.mix, clear type2.list of all but disabled
      if (!FileExists(md+MRingTxt) && type2) ClearTypeList(type2);
      // pubring.mix update
      if (MRingBox->Checked && !CorruptDoc(mring=GetDoc(MRingTxt)))
      {
         mixOk =
            MixCheckAddNewRemailerKeys(mring,type2) &&
            MixCheckGenType2(type2,mring) &&
            MixCheckType2NoDoubles(type2);
      }
      // mlist.txt update -- compare new mlist.txt with type2.txt
      if (MListBox->Checked && !CorruptDoc(mlist=GetDoc(MListTxt)) && mixOk)
         mixOk = !MixCheckListKeyNotFound(mlist,type2);
   }
   // test cyberpunk documents
   if (CListBox->Checked || CRingBox->Checked)
   {
      type1=GetDoc(CTyp1Txt);
      // if no pubring.asc, clear type1.list of all but disabled
      if (!FileExists(md+CRingTxt) && type1) ClearTypeList(type1);
      // pubring.asc update
      if (CRingBox->Checked && !CorruptDoc(cring=GetDoc(CRingTxt)))
      {
         cpkOk =
            CpkCheckAddNewRemailerKeys(cring,type1) &&
            CpkCheckGenType1(type1,cring) &&
            CpkCheckType1NoDoubles(type1);
      }
      // rlist.txt update -- compare new rlist.txt with type1.txt
      if (CListBox->Checked && !CorruptDoc(clist=GetDoc(CListTxt)) && cpkOk)
         cpkOk = !CpkCheckListKeyNotFound(clist,type1);
   }
   DocMemo->Cursor = crDefault;
   return mixOk && cpkOk;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::CpkCheckAddNewRemailerKeys(TStrings *CRing, TStrings *Type1)
{
   int added = CpkAddNewRemailerKeys(CRing,Type1);
   if (added)
   {
      Display("pubring.asc...adding "+s(added)+" new keys");
      AppProcessMessages(); Sleep(500);
      Display("pubring.asc...OK");
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::CpkCheckGenType1(TStrings *Type1, TStrings *CRing)
{
   Display("type1.list...generating entries");
   AppProcessMessages(); Sleep(500);
   CpkGenType1(Type1,CRing);
   Displas("type1.list...generating entries...OK");
   AppProcessMessages(); Sleep(500);
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::CpkCheckType1NoDoubles(TStrings *Type1)
{
  bool dbls=false;
  TStringList *items = new TStringList();
  Display("pubring.asc...checking duplicates");
  AppProcessMessages(); Sleep(500);
  items->Text = CpkType1Doubles(Type1);
  if (items->Count)
  {
     AppProcessMessages();
     Display("pubring.asc...DUPLICATE KEYS");
     Display(" The following keys on your Cyberpunk keyring appear");
     Display(" more than once. You will need to determine which is");
     Display(" current, and disable the older key. See Help");
     for (int i=0; i<items->Count; i++)
        if (!items->Strings[i].IsEmpty()) Display("  "+items->Strings[i]);
     Display("pubring.asc...DUPLICATE KEYS");
     AppProcessMessages(); Sleep(500);
     dbls = true;
  }
  if (!dbls) Displas("pubring.asc...checking duplicates...OK");
  AppProcessMessages(); Sleep(500);
  delete items;
  return !dbls;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::CpkCheckListKeyNotFound(TStrings *CList, TStrings *Type1)
{
   TStringList *items = new TStringList();
   TStringList *type1 = new TStringList();
   if (Type1) type1->Text = Type1->Text; else
   if (FileExists(MixDir()+CTyp1Txt)) type1->LoadFromFile(MixDir()+CTyp1Txt);

   bool found=false;
   Display("rlist.txt...comparing type1.list");
   AppProcessMessages(); Sleep(200);
   items->Text = CpkListKeyNotFound(CList,type1);
   if (items->Count)
   {
      AnsiString plu = items->Count==1 ? "" : "s";
      AnsiString cpkers = items->Count==1 ? "a Cpunk key" : "Cpunk keys";
      AppProcessMessages();
      Display("type1.list...KEY(S) NOT FOUND");
      Display(" There are "+s(items->Count)+s(" remailer")+s(plu)+s(" in your "));
      Display(" current Cyberpunk stats report (rlist.txt), for which, you ");
      Display(" have no public keys. You will probably want to obtain them. ");
      Display(" See Help");
    //Display("type1.list...KEY(S) NOT FOUND");
      AppProcessMessages(); Sleep(500);
      found = true;
   }
   if (!found) Displas("rlist.txt...comparing type1.list...OK");
   AppProcessMessages(); Sleep(200);
   delete type1;
   delete items;
   return found;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::MixCheckAddNewRemailerKeys(TStrings *MRing, TStrings *Type2)
{
   int added = MixAddNewRemailerKeys(MRing,Type2);
   if (added)
   {
      Display("pubring.mix...adding "+s(added)+" new keys");
      AppProcessMessages(); Sleep(500);
      Displas("pubring.mix...adding "+s(added)+" new keys...OK");
      AppProcessMessages(); Sleep(500);
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::MixCheckGenType2(TStrings *Type2, TStrings *MRing)
{
   Display("type2.list...generating entries");
   AppProcessMessages(); Sleep(500);
   MixGenType2(Type2,MRing);
   Displas("type2.list...generating entries...OK");
   AppProcessMessages(); Sleep(500);
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::MixCheckType2NoDoubles(TStrings *Type2)
{
  bool dbls=false;
  TStringList *items = new TStringList();
  items->Text = MixType2Doubles(Type2);
  Display("pubring.mix...checking duplicates");
  AppProcessMessages(); Sleep(500);
  if (items->Count)
  {
     AppProcessMessages();
     Display("pubring.mix...DUPLICATE KEYS");
     Display(" The following keys on your mixmaster keyring appear");
     Display(" more than once. You will need to determine which is");
     Display(" current, and disable the older key. See Help");
     for (int i=0; i<items->Count; i++) Display("  "+items->Strings[i]);
   //Display("pubring.mix...DUPLICATE KEYS");
     AppProcessMessages(); Sleep(500);
     dbls = true;
  }
  if (!dbls) Displas("pubring.mix...checking duplicates...OK");
  AppProcessMessages(); Sleep(500);
  delete items;
  return !dbls;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::MixCheckListKeyNotFound(TStrings *MList, TStrings *Type2)
{
   TStringList *items = new TStringList();
   TStringList *type2 = new TStringList();
   if ( Type2) type2->Text = Type2->Text; else
   if (FileExists(MixDir()+MTyp2Txt)) type2->LoadFromFile(MixDir()+MTyp2Txt);

   Display("mlist.txt...comparing type2.list");
   AppProcessMessages(); Sleep(200);

   bool found=false;
   items->Text = MixListKeyNotFound(MList,type2);
   if (items->Count)
   {
      AppProcessMessages();
      AnsiString plu = items->Count==1 ? "" : "s";
      Display("pubring.mix...KEY(S) NOT FOUND");
      if (items->Count==1)
      Display(" There is 1 remailer in your current mixmaster stats"); else
      Display(" There are "+s(items->Count)+" remailers in your current mixmaster stats");
      Display(" report (mlist.txt), for which, you have no public key"+plu+".");
      for (int i=0; i<items->Count; i++) Display("  "+items->Strings[i]);
      Display(" You will probably want to obtain them. See Help");
    //Display("pubring.mix...KEY(S) NOT FOUND");
      AppProcessMessages(); Sleep(500);
      found = true;
   }
   if (!found) Displas("mlist.txt...comparing type2.list...OK");
   AppProcessMessages(); Sleep(200);
   delete type2;
   delete items;
   return found;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::SaveStatistics()
{
   if (!GoodTabs()) return false;
   TStrings *TxtList;
   int i,bakcopies=STATSBAKCOPIES;
   AnsiString TxtFile,mtyp2txt=MixDir()+MTyp2Txt,ctyp1txt=MixDir()+CTyp1Txt;
   // copy current docmemo to tab stringlist to get possible edits
   SetTab(TabSet->TabIndex);
   // process tabs
   for (i=0; i<Tabs->Count; i++)
   {
      TxtList = GetDoc(i);
      TxtFile = Tabs->Strings[i];
      if (TxtFile=="Error" || TxtList==NULL || TxtList->Text.IsEmpty()) continue;
      if (TxtFile==ChecksPage) { SaveErrChkLog(TxtList); continue; }
      // special for pubring.asc, make single keyblock
      if (ErrorCheck->Checked && HasPgp() && TxtFile==CRingTxt)
         CpkKeysToBlock(TxtList);
      //==Save Statistics======================================
      SaveToFileBak(TxtList,MixDir()+TxtFile,bakcopies);
      //=======================================================
   }
   return true;
}
//---------------------------------------------------------------------------
int __fastcall THttpForm::GoodTabs()
{
   int valtabs=0;
   for (int i=0; i<Tabs->Count; i++)
   {
      TStringList *doc = GetDoc(i);
      if (Tabs->Strings[i]=="Error" || Tabs->Strings[i]==ChecksPage) continue;
      if (doc && doc->Count && doc->Text.Pos(CorruptReport)==1) continue;
      valtabs++;
   }
   return valtabs;
}
//---------------------------------------------------------------------------
TStringList* __fastcall THttpForm::TabDoc(int Index)
{
   // returns doc from tab or null if corrupt
   if (Index<0 || Index>=Tabs->Count) return NULL;
   TStringList *Doc = GetDoc(Index);
   if (Doc && Doc->Count && Doc->Text.Pos(CorruptReport)==1)
      Doc = NULL;
   return Doc;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::SetTab(int Index)
{
   if (Index>=0 && Index<Tabs->Count) // make sure tabdoc = docmemo
   {
      TStringList *doc = GetDoc(Index);
      if (!doc)
      {
         doc = new TStringList();
         Tabs->Objects[Index] = doc;
      }
      doc->Text = DocMemo->Lines->Text;
      DocMemo->Modified = false;
   }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::Timer2Timer(TObject *Sender)
{
//   Timer2->Enabled = false;
//   GetBtnClick();
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::FormShow(TObject *Sender)
{
   ActiveControl = Panel2;
   if (!Attended)
   {
      //LoadURLs();
      PostMessage(Handle,WM_GETBUTTONCLICK,0,NULL);
      //Timer2->Enabled = true;
      //return;
   }
   LoadURLs();
}
//---------------------------------------------------------------------------
AnsiString KeyRingCnt(int val)
{
   AnsiString v=AnsiString(val);
   if (v.Length()<2) v = " "+v; return v;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::CpkListOk(TStringList *Doc)
{
   AnsiString line,statsheader =
      s("remailer  email address                        history  latency  uptime\r\n")+
      s("-----------------------------------------------------------------------\r\n");
   int i,pos;
   for(int i=0; i<Doc->Count; i++)
   {
      line = Doc->Strings[i];
      while ((pos=line.Pos("&lt;"))>0) line.Delete(pos,4);
      while ((pos=line.Pos("&gt;"))>0) line.Delete(pos,4);
      if (line!=Doc->Strings[i]) Doc->Strings[i] = line;
   }
   if (Doc->Text.Pos(statsheader)==0)
   {
      Doc->Insert(0,CorruptReport);
      AppProcessMessages();
      Display("rlist.txt...CORRUPT");
      Display(" The new 'rlist.txt' document appears corrupt. I'm");
      Display(" unable to locate these statistics column headings.");
      Display(" \"remailer  email address        history  latency  uptime\"");
      Display(" The document has been marked so you can't accidentally");
      Display(" save it. See Help");
    //Display("rlist.txt...CORRUPT");
    //Display("OPERATION CANCELLED");
    //Display("Done!");
      AppProcessMessages(); Sleep(500);
      return false;
   }
   int c=0;
   for (i=0; i<Doc->Count; i++)
      if (CpkListLineOk(Doc->Strings[i])) c++;
   if (!c)
   {
      Doc->Insert(0,CorruptReport);
      AppProcessMessages();
      Display("rlist.txt...CORRUPT");
      Display(" The new 'rlist.txt' document appears corrupt. I've");
      Display(" located the stats column headers, but found no actual");
      Display(" stats lines at all. The document has been marked so");
      Display(" you can't accidentally save it. See Help");
    //Display("rlist.txt...CORRUPT");
    //Display("OPERATION CANCELLED");
    //Display("Done!");
      AppProcessMessages(); Sleep(500);
      return false;
   }
   Display("rlist.txt...OK");
   AppProcessMessages(); Sleep(500);
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::CpkRingOk(TStringList *Doc)
{
   int beg=0,end=0;
   AnsiString bline="-----BEGIN PGP PUBLIC KEY BLOCK-----";
   AnsiString eline="-----END PGP PUBLIC KEY BLOCK-----";
   for (int i=0; i<Doc->Count; i++)
   {
      AnsiString line=Doc->Strings[i].Trim();
      if (line==bline) beg++; else
      if (line==eline) end++;
   }
   if (!beg || !end || beg!=end)
   {
      Doc->Insert(0,CorruptReport);
      AppProcessMessages();
      Display("pubring.asc...CORRUPT");
      Display(" The new 'pubring.asc' document appears corrupt. The");
      Display(" values below should BOTH be greater than 0 AND equal.");
      Display(" "+KeyRingCnt(beg)+" \""+bline+"\" lines");
      Display(" "+KeyRingCnt(end)+" \""+eline+"\" lines");
      Display(" The document has been marked so you can't accidentally");
      Display(" save it."),
    //Display("pubring.asc...CORRUPT");
    //Display("OPERATION CANCELLED");
    //Display("Done!");
      AppProcessMessages(); Sleep(500);
      return false;
   }

   if (!HasPgp()) return true;

   TStringList *newkeys = new TStringList();
   newkeys->Text = CpkGetNewRemailerKeys(Doc);
   newkeys->Sorted = true;
   if (newkeys->Count)
   {
      AppProcessMessages();
      AnsiString s = newkeys->Count==1 ? "" : "s";
      Display("pubring.asc..."+s(newkeys->Count)+" NEW KEYS");
      Display(" The new 'pubring.asc' contains "+s(newkeys->Count)+" new key"+s+". These will be");
      Display(" added to your Cyberpunk keyring.");
      for (int k=0; k<newkeys->Count; k++)
         Display("  "+newkeys->Strings[k]);
    //Display("pubring.asc..."+s(newkeys->Count)+" NEW KEYS");
      AppProcessMessages(); Sleep(500);
   }
   delete newkeys;
   Display("pubring.asc...OK");
   AppProcessMessages(); Sleep(200);
   return true;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::Display(AnsiString &text)
{
   ActiveControl = DocMemo;
   DocMemo->Lines->Add(text);
   Application->ProcessMessages();
   Sleep(10);
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::Displas(AnsiString &text)
{
   DocMemo->Lines->Strings[DocMemo->Lines->Count-1] = text;
   Application->ProcessMessages();
   Sleep(10);
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::MixListOk(TStringList *Doc)
{
   AnsiString statsheader =
      s("mixmaster           history  latency  uptime\r\n")+
      s("--------------------------------------------\r\n");
   if (Doc->Text.Pos(statsheader)==0)
   {
      Doc->Insert(0,CorruptReport);
      AppProcessMessages(); Sleep(300);
      Display("mlist.txt...CORRUPT");
      Display(" The new 'mlist.txt' document appears corrupt. I'm");
      Display(" unable to locate these statistics columns headings.");
      Display(" \"mixmaster           history  latency  uptime\"");
      Display(" The document has been marked so you can't accidentally");
      Display(" save it. See Help");
    //Display("mlist.txt...CORRUPT");
    //Display("OPERATION CANCELLED");
    //Display("Done!");
      AppProcessMessages();
      return false;
   }
   int c=0; for (int i=0; i<Doc->Count; i++)
      if (MixListLineOk(Doc->Strings[i])) c++;
   if (!c)
   {
      Doc->Insert(0,CorruptReport);
      AppProcessMessages();
      Display("mlist.txt...CORRUPT");
      Display(" The new 'mlist.txt' document appears corrupt. I've");
      Display(" located the stats column headers, but found no actual");
      Display(" stats lines at all. The document has been marked so");
      Display(" you can't accidentally save it.");
    //Display("mlist.txt...CORRUPT");
    //Display("OPERATION CANCELLED");
    //Display("Done!");
      AppProcessMessages(); Sleep(500);
      return false;
   }
   Display("mlist.txt...OK");
   AppProcessMessages(); Sleep(200);
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::MixRingOk(TStringList *Doc)
{
   int dc=0,beg=0,end=0;
   AnsiString line,descrip,s;
   for (int i=0; i<Doc->Count; i++)
   {
      line = Doc->Strings[i];
      if (line=="-----Begin Mix Key-----") beg++; else
      if (line=="-----End Mix Key-----") end++; else
      if (MixRingLineOk(line)) dc++;
   }
   if (!(dc>0 && dc==beg && beg==end))
   {
      Doc->Insert(0,CorruptReport);
      AppProcessMessages();
      Display("pubring.mix...CORRUPT");
      Display(" The new 'pubring.mix' document appears corrupt. The");
      Display(" values below should ALL be greater than 0 AND equal.");
      Display("  "+KeyRingCnt(dc)+" Mix Key description lines");
      Display("  "+KeyRingCnt(beg)+" \"-----Begin Mix Key-----\" lines");
      Display("  "+KeyRingCnt(end)+" \"-----End Mix Key-----\" lines");
      Display(" The document has been marked so you can't accidentally");
      Display(" save it.");
    //Display("pubring.mix...CORRUPT");
      AppProcessMessages(); Sleep(300);
      return false;
   }
   // doc is ok, check for new keys
   TStringList *newkeys = new TStringList();
   newkeys->Text = MixGetNewRemailerKeys(Doc);
   newkeys->Sorted = true;
   // notify of new keys, if any
   if (newkeys->Count)
   {
      s = newkeys->Count==1 ? "" : "s";
      AppProcessMessages();
      Display("pubring.mix..."+s(newkeys->Count)+" NEW KEYS");
      Display(" The new 'pubring.mix' contains "+s(newkeys->Count)+" new key"+s+". These will be");
      Display(" added to your Mixmaster keyring.");
      for (int i=0; i<newkeys->Count; i++)
      {
         descrip = "";
         for (int f=0; f<5; f++)
         {
            if (f==1) descrip = descrip+s("           ").SubString(1,11-descrip.Length());
            descrip += "  "+GetParam(f,newkeys->Strings[i]," ");
            //if (f!=2) descrip += "  "+GetParam(f,newkeys->Strings[i]," ");
         }
         Display("  "+descrip.Trim());
      }
      Display("pubring.mix..."+s(newkeys->Count)+" NEW KEYS");
      AppProcessMessages(); Sleep(500);
   }
   Display("pubring.mix...OK");
   AppProcessMessages(); Sleep(200);
   delete newkeys;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::GetStatistics(AnsiString &forURL, TCheckBox *Box,
   AnsiString &Doc)
{
   CurDoc = Doc;
   CurBox = Box;
   Cap = forURL;//+"...";
   Label1->Caption = Cap;
   //CancelBtn->Caption = "Cancel";
   HttpCli1->URL = forURL;
   HttpCli1->Proxy = ProxyHostEdit->Text;
   HttpCli1->ProxyPort = ProxyPortEdit->Text;
   HttpCli1->ProxyUsername = ProxyUserEdit->Text;
   HttpCli1->ProxyPassword = ProxyPswdEdit->Text;
   HttpCli1->ModifiedSince = 0;
   ProgressBar1->Position = 0;
   ProgressBar1->Visible = true;

   BytesReceived = 0;
   //Timer3->Enabled = true;
   CurTime = 0;

   try {
       HttpCli1->HeadASync();
   } __except (TRUE) {
       //GetDocs->Enabled = true;
       TabSheet1->Enabled = true;
       TabSheet2->Enabled = true;

       DocMemo->Clear();
       DocMemo->Lines->Add("Head Failed !");
       DocMemo->Lines->Add("Status = " + IntToStr(HttpCli1->StatusCode));
       DocMemo->Lines->Add("Reason = " + HttpCli1->ReasonPhrase);
       PageControl1->ActivePage = TabSheet3;
       ProgressBar1->Visible = false;
       Timer3->Enabled = false;

       return false;
   }
   return !Cancelled;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::LoadHttpInfo()
{
   TStringList *http = new TStringList();
   if (AppDataExists(HttpInfo,http))
   {
      MListBox->Checked = http->Values["MListChkd"] == "1";
      MRingBox->Checked = http->Values["MRingChkd"] == "1";
      MTyp2Box->Checked = http->Values["MTyp2Chkd"] == "1";
      CListBox->Checked = http->Values["CListChkd"] == "1";
      CRingBox->Checked = http->Values["CRingChkd"] == "1";
      ProxyHostEdit->Text = http->Values["ProxyHost"];
      ProxyPortEdit->Text = http->Values["ProxyPort"];
      ProxyPswdEdit->Text = http->Values["ProxyPswd"];
      ProxyUserEdit->Text = http->Values["ProxyUser"];
   }
   Http = http->Text; // keep for later compare to see if modified
   delete http;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::StoreHttpInfo()
{
   TStringList *http = new TStringList();
   http->Add("MListChkd="+AnsiString(MListBox->Checked?"1":"0"));
   http->Add("MRingChkd="+AnsiString(MRingBox->Checked?"1":"0"));
   http->Add("MTyp2Chkd="+AnsiString(MTyp2Box->Checked?"1":"0"));
   http->Add("CListChkd="+AnsiString(CListBox->Checked?"1":"0"));
   http->Add("CRingChkd="+AnsiString(CRingBox->Checked?"1":"0"));
   http->Add("ProxyHost="+ProxyHostEdit->Text);
   http->Add("ProxyPort="+ProxyPortEdit->Text);
   http->Add("ProxyPswd="+ProxyPswdEdit->Text);
   http->Add("ProxyUser="+ProxyUserEdit->Text);
   if (Http!=http->Text) // test for modified
      PutAppData(HttpInfo,http);
   delete http;
}
//---------------------------------------------------------------------------
bool __fastcall THttpForm::Execute(bool attended)
{
   Attended = attended; ShowModal();
   return ModalResult==mrOk;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::ResetCheckboxes()
{
   Timer1->Enabled = false;
   if (MListBox->Checked) MListBox->Enabled = true;
   if (MRingBox->Checked) MRingBox->Enabled = true;
   if (MTyp2Box->Checked) MTyp2Box->Enabled = true;
   if (CListBox->Checked) CListBox->Enabled = true;
   if (CRingBox->Checked) CRingBox->Enabled = true;
/*   if (Attended)
   {
      GetDocs->Enabled = true;
      HelpBtn->Enabled = true;
      OkBtn->Enabled = true;
   }*/
   TabSheet1->Enabled = true;
   TabSheet2->Enabled = true;
   Cancelled = false;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::HttpCli1DocBegin(TObject *Sender)
{
   BytesReceived = 0;
   ProgressBar1->Position = 0;
   if (HttpCli1->RcvdStream) delete HttpCli1->RcvdStream;
   HttpCli1->RcvdStream = new TMemoryStream();
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::HttpCli1DocData(TObject *Sender, Pointer Buffer, int Len)
{
   if (BytesTotal>0)
   {
      BytesReceived += Len;
      ProgressBar1->Position = (BytesReceived/BytesTotal)*100;
      if (BytesReceived==BytesTotal) Sleep(200);
   }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::HttpCli1DocEnd(TObject *Sender)
{
   ProgressBar1->Position = 0;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::SetDoc(AnsiString DocName, TStrings *Doc)
{
   int Index=Tabs->IndexOf(DocName);
   if (Index>=0 && Index<Tabs->Count)
   {
      TStringList *del=GetDoc(Index);
      if (del) delete del;
      Tabs->Objects[Index] = Doc;
   }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::SetDoc(int Index, TStrings *Doc)
{
   if (Index>=0 && Index<Tabs->Count)
   {
      TStringList *del=GetDoc(Index);
      if (del) delete del;
      Tabs->Objects[Index] = Doc;
   }
}
//---------------------------------------------------------------------------
TStringList* __fastcall THttpForm::GetDoc(AnsiString DocName)
{
   int Index=Tabs->IndexOf(DocName);
   if (Index<0 || Index>=Tabs->Count) return NULL;
   return dynamic_cast<TStringList*>(Tabs->Objects[Index]);
}
//---------------------------------------------------------------------------
TStringList* __fastcall THttpForm::GetDoc(int Index)
{
   if (Index<0 || Index>=Tabs->Count) return NULL;
   return dynamic_cast<TStringList*>(Tabs->Objects[Index]);
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::HttpCli1RequestDone(TObject *Sender,
	THttpRequest RqType, WORD Error)
{
   TStringList *tmp;
   AnsiString s,TxtFile;
   if (Error)
   {
      //GetBtn->Caption = "Done";
      PageControl1->ActivePage = TabSheet3;
      TStringList *tmp = new TStringList();
      tmp->Add("HTTP Error = "+AnsiString(Error));
      tmp->Add("HTTP Reason = "+HttpCli1->ReasonPhrase);
      TabSet->Tabs->AddObject("Error",tmp);
      TabSet->TabIndex = TabSet->Tabs->Count-1;
      DocMemo->Lines->Text = tmp->Text;
      UrlsBtn->Enabled = true;
      ProxyBtn->Enabled = true;
      Timer3->Enabled = false;
      return;
   }
   switch (RqType)
   {
      case httpHEAD:
      {
         //sm(HttpCli1->RcvdHeader->Text);
         for (int i=0; i<HttpCli1->RcvdHeader->Count; i++)
         {
            s = HttpCli1->RcvdHeader->Strings[i];
            if (s.Pos("Content-Length: ")==1)
               BytesTotal = s.SubString(17,16).ToIntDef(0);
         }
         HttpCli1->GetASync();
         break;
      }
      case httpGET:
      {
         Timer3->Enabled = false;
         tmp = new TStringList();
         HttpCli1->RcvdStream->Seek(0,soFromBeginning);
         tmp->LoadFromStream(HttpCli1->RcvdStream);
         Tabs->AddObject(CurDoc,NULL);
         TabSet->TabIndex = Tabs->Count-1;
         Label1->Caption = "";
         SetDoc(CurDoc,tmp);
         AppProcessMessages();

         // handle html
         AnsiString doc = tmp->Text.UpperCase();
         if (doc.Pos("<HTML>") && doc.Pos("<PRE>") && doc.Pos("</PRE>"))
         {
            while (tmp->Count && tmp->Strings[0].UpperCase().Trim()!="<PRE>")
               tmp->Delete(0); if (tmp->Count) tmp->Delete(0);
            while (tmp->Count && tmp->Strings[tmp->Count-1].UpperCase().Trim()!="</PRE>")
               tmp->Delete(tmp->Count-1);
            if (tmp->Count) tmp->Delete(tmp->Count-1);
         }
         // get rid of stupid banner  << these may make a bogus report empyt
         if (CurDoc==CListTxt && tmp->Text.Pos("$remailer{"))
            while (tmp->Count && !tmp->Strings[0].Pos("$remailer{"))
               tmp->Delete(0);
         // get rid of stupid remailer banner
         if (CurDoc==MListTxt && tmp->Text.Pos("Last update: "))
           while (tmp->Count && !tmp->Strings[0].LowerCase().Pos("last update: "))
              tmp->Delete(0);

         // set document
         SetDocMemo(tmp,false);
         AppProcessMessages(); Sleep(500);
         CurBox->Enabled = false;
         AppProcessMessages();

         if (CurDoc==MRingTxt && ErrorCheck->Checked && HasMix())
         {
            GetDocument(MTyp2Txt);
            Application->ProcessMessages(); Sleep(1000);
         }
         else
         if (CurDoc==CRingTxt && ErrorCheck->Checked && HasPgp())
         {
            GetDocument(CTyp1Txt);
            Application->ProcessMessages(); Sleep(1000);
         }
         else Sleep(300);

         if (PageControl1->ActivePage!=TabSheet3)
            PageControl1->ActivePage=TabSheet3;
         // test validity of documents...
         GetBtnClick();
         delete HttpCli1->RcvdStream; HttpCli1->RcvdStream = NULL;
         break;
      }
   }
}
//---------------------------------------------------------------------------
AnsiString __fastcall THttpForm::GetDefaultURL(AnsiString &DocName)
{
   AnsiString URL;
   if (DocName==MListTxt) URL = MListCBox->Text;
   if (DocName==MRingTxt) URL = MRingCBox->Text;
   if (DocName==MTyp2Txt) URL = MTyp2CBox->Text;
   if (DocName==CListTxt) URL = CListCBox->Text;
   if (DocName==CRingTxt) URL = CRingCBox->Text;
   return URL;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::GetAppURLs()
{
   if ((MListURL = GetDefaultURL(MListTxt))=="") {
      MListBox->Checked=false; MListBox->Enabled=false;
   } else MListBox->Enabled=true;

   if ((MRingURL = GetDefaultURL(MRingTxt))=="") {
      MRingBox->Checked=false; MRingBox->Enabled=false;
   } else MRingBox->Enabled=true;

   if ((MTyp2URL = GetDefaultURL(MTyp2Txt))=="" || ErrorCheck->Checked) {
      MTyp2Box->Checked=false; MTyp2Box->Enabled=false;
   } else MTyp2Box->Enabled=true;

   if ((CListURL = GetDefaultURL(CListTxt))=="") {
      CListBox->Checked=false; CListBox->Enabled=false;
   } else CListBox->Enabled=true;
   if ((CRingURL = GetDefaultURL(CRingTxt))=="") {
      CRingBox->Checked=false; CRingBox->Enabled=false;
   } else CRingBox->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::CancelBtnClick(TObject *Sender)
{
   Timer3->Enabled = false;
   Timer1->Enabled = false; Label1->Caption = "";
   OkBtn->Enabled = true;
   HelpBtn->Enabled = true;
   Attended = true;
   if (!GetDocs->Enabled)
   {
      GetDocs->Enabled = true;
      TabSheet1->Enabled = true;
      TabSheet2->Enabled = true;
      CancelAnyway = true;
      HttpCli1->Abort();
      Attended = true;
      return;
   }
   ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::Timer1Timer(TObject *Sender)
{
   if (Label1->Caption=="") Label1->Caption = Cap; else Label1->Caption = "";
   Application->ProcessMessages();
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::ProxyPswdBoxClick(TObject *Sender)
{
   if (!ProxyPswdBox->Checked)
      ProxyPswdEdit->PasswordChar = '\0';
   else
      ProxyPswdEdit->PasswordChar = '*';
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::PageControl1Changing(TObject *Sender,
  bool &AllowChange)
{
   if (PageControl1->ActivePage==TabSheet3)
      ActiveControl = DocMemo;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::UrlsBtnClick(TObject *Sender)
{
   if (ManageURLs(this,ErrorCheck->Checked))
   {
      MListCBox->Clear();
      MRingCBox->Clear();
      MTyp2CBox->Clear();
      CListCBox->Clear();
      CRingCBox->Clear();
      AppProcessMessages();
      Sleep(200);
      LoadURLs();
   }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::SetDocMemo(TStrings *Doc, bool SaveCur)
{
   int Index=TabSet->TabIndex;
   if (SaveCur && Index>=0 && Index<Tabs->Count && DocMemo->Modified)
   {
      TStringList *doc = new TStringList();
      doc->Text = DocMemo->Lines->Text;
      SetDoc(Index,doc);
   }
   DocMemo->Clear();
   if (Doc)
      DocMemo->Lines->Text = Doc->Text;
   DocMemo->Modified = false;
   DocMemo->SelStart = 0;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::TabSetChange(TObject *Sender, int NewTab,
   bool &AllowChange)
{
   SetRedraw(DocMemo,false);
   TStringList *doc=new TStringList();
   doc->Text = DocMemo->Lines->Text;
   int Index = TabSet->TabIndex;
   if (Index>=0 && Index<Tabs->Count && DocMemo->Modified)
       SetDoc(Index,doc);

   doc = GetDoc(NewTab);
   DocMemo->Lines->Text = doc ? doc->Text:AnsiString("");
   DocMemo->Modified = false;
   DocMemo->SelStart = 0;
   SetRedraw(DocMemo,true);
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::FormResize(TObject *Sender)
{
   HelpBtn->Left = Width - 92;
   CancelBtn->Left = HelpBtn->Left - 75;
   OkBtn->Left = CancelBtn->Left - 75;
   GetDocs->Left = OkBtn->Left - 75;
   ProgressBar1->Width = GetDocs->Left - 30;
   Label1->Top = Height - 74;
   Label1->Width = Width - 42;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::ErrorCheckClick(TObject *Sender)
{
  if (ErrorCheck->Checked)
  {
     MTyp2CBox->Visible = false;
     MTyp2Box->Checked = false; MTyp2Box->Enabled = false;
     CTyp1Box->Visible = true;
  }
  else
  {
     MTyp2CBox->Visible = true;
     CTyp1Box->Visible = false;
     MTyp2Box->Enabled = true;
  }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::CRingBoxClick(TObject *Sender)
{
   if (CRingBox->Checked) CListBox->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::MRingBoxClick(TObject *Sender)
{
   if (MRingBox->Checked) MListBox->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::HelpBtnClick(TObject *Sender)
{
   AnsiString sections;
   TTabSheet *tab = PageControl1->ActivePage;
   if (tab==TabSheet1)
   {
      sections="Remailer\nRemailerUrl";
      if (ErrorCheck->Checked)
      {
         sections += "\nRemailerError";
//         if (HasMix()) sections += "\nUpdateMixDocs";
//         if (HasPgp()) sections += "\nUpdateCpkDocs";
//         if (GetAppIni(StatsErrCheck,"").ToIntDef(1)) sections += "\nRemailerClear";
      }
      OpenHelp(sections,"Remailers & Remailer Documents","Remailer Dialog",NULL);//Application->MainForm);
   }
   else
   if (tab==TabSheet2)
   {
      OpenHelp("ProxyHTTP","Remailer Documents and Proxies","Proxy Host",NULL);//Application->MainForm);
   }
   else
   if (tab==TabSheet3)
   {
      sections="RemailerError";
      if (ErrorCheck->Checked)
      {
//         sections += "\nRemailerError";
//         if (HasMix()) sections += "\nUpdateMixDocs";
//         if (HasPgp()) sections += "\nUpdateCpkDocs";
//         if (GetAppIni(StatsErrCheck,"").ToIntDef(1)) sections += "\nRemailerClear";
      }
      OpenHelp(sections,"Remailers & Remailer Documents","Remailer Dialog",NULL);//AppMainForm);
   }
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::ProxyBtnClick(TObject *Sender)
{
   TabSheet2->TabVisible = true;
   PageControl1->ActivePage = TabSheet2;
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::DocCBoxChange(TObject *Sender)
{
/*
   TComboBox *cb = dynamic_cast<TComboBox*>(Sender);
   AnsiString def=cb->Text;
   cb->Items->Delete(cb->Items->IndexOf(def));
   cb->Items->Insert(0,def);
   cb->ItemIndex = 0;
   switch(cb->Tag)
   {
      case 1: PutAppData(StatsURLs+PS+MListTxt,cb->Items); break;
      case 2: PutAppData(StatsURLs+PS+MRingTxt,cb->Items); break;
      case 3: PutAppData(StatsURLs+PS+MTyp2Txt,cb->Items); break;
      case 4: PutAppData(StatsURLs+PS+CListTxt,cb->Items); break;
      case 5: PutAppData(StatsURLs+PS+CRingTxt,cb->Items); break;
   }
*/
}
//---------------------------------------------------------------------------
void __fastcall THttpForm::Timer3Timer(TObject *Sender)
{
   CurTime++;
   if (CurTime>=TimeOut)
   {
      HttpCli1->Abort();
      Timer3->Enabled = false;
      Timer1->Enabled = false; Label1->Caption = "";
      MsgBoxHwnd(Handle,"Operation has timed out! Aborting!","Time Out",MB_OK);
      GetBtnClick();
   }
}
//---------------------------------------------------------------------------
